//
// oplist.C - Rendering Ops and lists of them
//

/*...sincludes:0:*/
#include "oplist.h"

/*...voplist\46\h:0:*/
/*...e*/

/*...sempty:0:*/
void OpList::empty()
	{
	Op *next;
	for ( Op *op = first; op != 0; op = next )
		{
		next = op->next;
		delete op;
		}
	first = last = 0;
	}
/*...e*/
/*...sappend \40\list\41\:0:*/
void OpList::append(const OpList & ol)
	{
	for ( Op *op = ol.first; op != 0; op = op->next )
		{
		Op *op2 = op->copy();
		if ( op2 == 0 )
			break;
		append(op2);
		}
	}
/*...e*/

/*...sOpList:0:*/
OpList::OpList() : first(0), last(0) {}
/*...e*/
/*...sOpList \40\copy\41\:0:*/
OpList::OpList(const OpList & ol)
	:
	first(0), last(0)
	{
	append(ol);
	}
/*...e*/
/*...soperator\61\:0:*/
OpList & OpList::operator=(const OpList & ol)
	{
	if ( &ol != this )
		{
		empty();
		append(ol);
		}
	return *this;
	}
/*...e*/
/*...soperator\43\\61\:0:*/
OpList & OpList::operator+=(const OpList & ol)
	{
	append(ol);
	return *this;
	}
/*...e*/
/*...s\126\OpList:0:*/
OpList::~OpList() { empty(); }
/*...e*/
