//
// progxwin.h - Display Progress using XWindows window
//
// The Bitmap being watched must be 24bpp.
// If you use this you'll need to link with gbmerr.lib.
//

#ifndef PROGXWIN_H
#define	PROGXWIN_H

/*...sincludes:0:*/
#include "types.h"
#include "bitmap.h"
#include "progress.h"

/*...vtypes\46\h:0:*/
/*...vbitmap\46\h:0:*/
/*...vprogress\46\h:0:*/
/*...e*/

class ProgressXWinInternal;

class ProgressXWin : public Progress
	{
	ProgressXWinInternal *pwi;
public:
	ProgressXWin(
		Bitmap & b,
		const char *title = 0,
		const char *display = 0,
		const char *geometry = 0
		);
	virtual ~ProgressXWin();
	virtual void begin();
	virtual void done(int sofar, int total);
	virtual void end();
	virtual void message(const char *message);
	};

#endif
