//
// viewvio.h - Viewer for a bitmap using OS/2 Vio Fullscreen
//
// The Bitmap being viewed must be 8bpp.
// It must be 320x200 pixels or smaller.
// Only one ViewerVio or ProgressVio object may be created at once.
// If you use this, then you'll need to ilink /PMTYPE:NOVIO.
//

#ifndef VIEWVIO_H
#define	VIEWVIO_H

/*...sincludes:0:*/
extern "C" {
#include "gbm.h"
}

#include "types.h"
#include "bitmap.h"
#include "viewer.h"

/*...vtypes\46\h:0:*/
/*...vbitmap\46\h:0:*/
/*...vviewer\46\h:0:*/
/*...e*/

class ViewerVio : public Viewer
	{
/*...sprivate:8:*/
GBM *gbm;
GBMRGB *gbmrgb;
Byte *data;
/*...e*/
public:
	ViewerVio(Bitmap & b, int ncols = 0x100, int border = 0);
	virtual ~ViewerVio();
	virtual void refresh();
	virtual int keypress();
	virtual int wait_keypress();
	};

#endif
