//
// viewxwin.h - Viewer for a bitmap using XWindows Window
//
// The Bitmap being viewed can be 1,4,8 or 24bpp.
// If you use this you'll need to link with gbmerr.lib.
//

#ifndef VIEWXWIN_H
#define	VIEWXWIN_H

/*...sincludes:0:*/
#include "types.h"
#include "bitmap.h"
#include "viewer.h"

/*...vtypes\46\h:0:*/
/*...vbitmap\46\h:0:*/
/*...vviewer\46\h:0:*/
/*...e*/

class ViewerXWinInternal;

class ViewerXWin : public Viewer
	{
	ViewerXWinInternal *vwi;
public:
	ViewerXWin(
		Bitmap & b,
		int ncols = 0x100,
		const char *title = 0,
		const char *display = 0,
		const char *geometry = 0
		);
	virtual ~ViewerXWin();
	virtual void refresh();
	virtual int keypress();
	virtual int wait_keypress();
	};

#endif
